Solid Example: Store Context

import { render } from 'solid-js/web'
import {
  createAtom,
  createStore,
  createStoreContext,
  useAtom,
  useSelector,
} from '@tanstack/solid-store'
import type { Atom, Store } from '@tanstack/solid-store'

// one drawback of storing stores and atoms in context is you have to define types for the context manually, instead of everything being inferred.

type CounterStore = {
  cats: number
  dogs: number
}

type StoreContextValue = {
  votesStore: Store<CounterStore>
  countAtom: Atom<number>
}

// create context provider and hook
const { StoreProvider, useStoreContext } =
  createStoreContext<StoreContextValue>()

function App() {
  // Solid components only run once per mount, so stores and atoms created here stay stable for this provider instance.
  const votesStore = createStore<CounterStore>({
    cats: 0,
    dogs: 0,
  })
  const countAtom = createAtom(0)

  return (
    <StoreProvider value={{ votesStore, countAtom }}>
      <main>
        <h1>Solid Store Context</h1>
        <p>
          This example provides both atoms and stores through a single typed
          context object, then consumes them from nested components.
        </p>
        <CatCard />
        <DogCard />
        <TotalCard />
        <StoreButtons />
        <section>
          <h2>Nested Atom Components</h2>
          <AtomSummary />
          <NestedAtomControls />
          <DeepAtomEditor />
        </section>
      </main>
    </StoreProvider>
  )
}

function CatCard() {
  // pull a store from context
  const { votesStore } = useStoreContext()
  // select a value from the store with useSelector
  const value = useSelector(votesStore, (state) => state.cats)

  return <p>Cats: {value()}</p>
}

function DogCard() {
  // pull a store from context
  const { votesStore } = useStoreContext()
  // select a value from the store with useSelector
  const value = useSelector(votesStore, (state) => state.dogs)

  return <p>Dogs: {value()}</p>
}

function TotalCard() {
  // pull a store from context
  const { votesStore } = useStoreContext()
  // custom selector to calculate total votes from the store state
  const total = useSelector(votesStore, (state) => state.cats + state.dogs)

  return <p>Total votes: {total()}</p>
}

function AtomSummary() {
  // pull an atom from context
  const { countAtom } = useStoreContext()
  const count = useSelector(countAtom)

  return <p>Atom count: {count()}</p>
}

function NestedAtomControls() {
  const { countAtom } = useStoreContext()

  return (
    <div>
      <button type="button" onClick={() => countAtom.set((prev) => prev + 1)}>
        Increment atom
      </button>
      <button type="button" onClick={() => countAtom.set(0)}>
        Reset atom
      </button>
    </div>
  )
}

function DeepAtomEditor() {
  const { countAtom } = useStoreContext()
  const [count, setCount] = useAtom(countAtom)

  return (
    <div>
      <p>Editable atom count: {count()}</p>
      <button type="button" onClick={() => setCount((prev) => prev + 5)}>
        Add 5 to atom
      </button>
    </div>
  )
}

function StoreButtons() {
  const { votesStore } = useStoreContext()

  return (
    <div>
      <button
        type="button"
        onClick={() =>
          votesStore.setState((prev) => ({
            ...prev,
            cats: prev.cats + 1,
          }))
        }
      >
        Add cat
      </button>
      <button
        type="button"
        onClick={() =>
          votesStore.setState((prev) => ({
            ...prev,
            dogs: prev.dogs + 1,
          }))
        }
      >
        Add dog
      </button>
    </div>
  )
}

render(() => <App />, document.getElementById('root')!)
import { render } from 'solid-js/web'
import {
  createAtom,
  createStore,
  createStoreContext,
  useAtom,
  useSelector,
} from '@tanstack/solid-store'
import type { Atom, Store } from '@tanstack/solid-store'

// one drawback of storing stores and atoms in context is you have to define types for the context manually, instead of everything being inferred.

type CounterStore = {
  cats: number
  dogs: number
}

type StoreContextValue = {
  votesStore: Store<CounterStore>
  countAtom: Atom<number>
}

// create context provider and hook
const { StoreProvider, useStoreContext } =
  createStoreContext<StoreContextValue>()

function App() {
  // Solid components only run once per mount, so stores and atoms created here stay stable for this provider instance.
  const votesStore = createStore<CounterStore>({
    cats: 0,
    dogs: 0,
  })
  const countAtom = createAtom(0)

  return (
    <StoreProvider value={{ votesStore, countAtom }}>
      <main>
        <h1>Solid Store Context</h1>
        <p>
          This example provides both atoms and stores through a single typed
          context object, then consumes them from nested components.
        </p>
        <CatCard />
        <DogCard />
        <TotalCard />
        <StoreButtons />
        <section>
          <h2>Nested Atom Components</h2>
          <AtomSummary />
          <NestedAtomControls />
          <DeepAtomEditor />
        </section>
      </main>
    </StoreProvider>
  )
}

function CatCard() {
  // pull a store from context
  const { votesStore } = useStoreContext()
  // select a value from the store with useSelector
  const value = useSelector(votesStore, (state) => state.cats)

  return <p>Cats: {value()}</p>
}

function DogCard() {
  // pull a store from context
  const { votesStore } = useStoreContext()
  // select a value from the store with useSelector
  const value = useSelector(votesStore, (state) => state.dogs)

  return <p>Dogs: {value()}</p>
}

function TotalCard() {
  // pull a store from context
  const { votesStore } = useStoreContext()
  // custom selector to calculate total votes from the store state
  const total = useSelector(votesStore, (state) => state.cats + state.dogs)

  return <p>Total votes: {total()}</p>
}

function AtomSummary() {
  // pull an atom from context
  const { countAtom } = useStoreContext()
  const count = useSelector(countAtom)

  return <p>Atom count: {count()}</p>
}

function NestedAtomControls() {
  const { countAtom } = useStoreContext()

  return (
    <div>
      <button type="button" onClick={() => countAtom.set((prev) => prev + 1)}>
        Increment atom
      </button>
      <button type="button" onClick={() => countAtom.set(0)}>
        Reset atom
      </button>
    </div>
  )
}

function DeepAtomEditor() {
  const { countAtom } = useStoreContext()
  const [count, setCount] = useAtom(countAtom)

  return (
    <div>
      <p>Editable atom count: {count()}</p>
      <button type="button" onClick={() => setCount((prev) => prev + 5)}>
        Add 5 to atom
      </button>
    </div>
  )
}

function StoreButtons() {
  const { votesStore } = useStoreContext()

  return (
    <div>
      <button
        type="button"
        onClick={() =>
          votesStore.setState((prev) => ({
            ...prev,
            cats: prev.cats + 1,
          }))
        }
      >
        Add cat
      </button>
      <button
        type="button"
        onClick={() =>
          votesStore.setState((prev) => ({
            ...prev,
            dogs: prev.dogs + 1,
          }))
        }
      >
        Add dog
      </button>
    </div>
  )
}

render(() => <App />, document.getElementById('root')!)

Angular Example: Store Context

import { Component } from '@angular/core'
import {
  createAtom,
  createStore,
  createStoreContext,
  injectAtom,
  injectSelector,
} from '@tanstack/angular-store'
import type { Atom, Store } from '@tanstack/angular-store'

type CounterStore = {
  cats: number
  dogs: number
}

const { provideStoreContext, injectStoreContext } = createStoreContext<{
  votesStore: Store<CounterStore>
  countAtom: Atom<number>
}>()

@Component({
  selector: 'app-root',
  standalone: true,
  providers: [
    provideStoreContext(() => ({
      votesStore: createStore<CounterStore>({
        cats: 0,
        dogs: 0,
      }),
      countAtom: createAtom(0),
    })),
  ],
  template: `
    <main>
      <h1>Angular Store Context</h1>
      <p>
        This example provides both atoms and stores through Angular DI via
        \`createStoreContext\`, then consumes them from the same component tree
        with TanStack Store hooks.
      </p>
      <p>Cats: {{ cats() }}</p>
      <p>Dogs: {{ dogs() }}</p>
      <p>Total votes: {{ total() }}</p>
      <div>
        <button type="button" (click)="addCat()">Add cat</button>
        <button type="button" (click)="addDog()">Add dog</button>
      </div>
      <section>
        <h2>Nested Atom Components</h2>
        <p>Atom count: {{ count() }}</p>
        <div>
          <button type="button" (click)="count.set((prev) => prev + 1)">
            Increment atom
          </button>
          <button type="button" (click)="count.set(0)">Reset atom</button>
        </div>
      </section>
    </main>
  `,
})
export class AppComponent {
  private ctx = injectStoreContext()

  cats = injectSelector(this.ctx.votesStore, (state) => state.cats)
  dogs = injectSelector(this.ctx.votesStore, (state) => state.dogs)
  total = injectSelector(
    this.ctx.votesStore,
    (state) => state.cats + state.dogs,
  )
  count = injectAtom(this.ctx.countAtom)

  addCat() {
    this.ctx.votesStore.setState((prev) => ({
      ...prev,
      cats: prev.cats + 1,
    }))
  }

  addDog() {
    this.ctx.votesStore.setState((prev) => ({
      ...prev,
      dogs: prev.dogs + 1,
    }))
  }
}
import { Component } from '@angular/core'
import {
  createAtom,
  createStore,
  createStoreContext,
  injectAtom,
  injectSelector,
} from '@tanstack/angular-store'
import type { Atom, Store } from '@tanstack/angular-store'

type CounterStore = {
  cats: number
  dogs: number
}

const { provideStoreContext, injectStoreContext } = createStoreContext<{
  votesStore: Store<CounterStore>
  countAtom: Atom<number>
}>()

@Component({
  selector: 'app-root',
  standalone: true,
  providers: [
    provideStoreContext(() => ({
      votesStore: createStore<CounterStore>({
        cats: 0,
        dogs: 0,
      }),
      countAtom: createAtom(0),
    })),
  ],
  template: `
    <main>
      <h1>Angular Store Context</h1>
      <p>
        This example provides both atoms and stores through Angular DI via
        \`createStoreContext\`, then consumes them from the same component tree
        with TanStack Store hooks.
      </p>
      <p>Cats: {{ cats() }}</p>
      <p>Dogs: {{ dogs() }}</p>
      <p>Total votes: {{ total() }}</p>
      <div>
        <button type="button" (click)="addCat()">Add cat</button>
        <button type="button" (click)="addDog()">Add dog</button>
      </div>
      <section>
        <h2>Nested Atom Components</h2>
        <p>Atom count: {{ count() }}</p>
        <div>
          <button type="button" (click)="count.set((prev) => prev + 1)">
            Increment atom
          </button>
          <button type="button" (click)="count.set(0)">Reset atom</button>
        </div>
      </section>
    </main>
  `,
})
export class AppComponent {
  private ctx = injectStoreContext()

  cats = injectSelector(this.ctx.votesStore, (state) => state.cats)
  dogs = injectSelector(this.ctx.votesStore, (state) => state.dogs)
  total = injectSelector(
    this.ctx.votesStore,
    (state) => state.cats + state.dogs,
  )
  count = injectAtom(this.ctx.countAtom)

  addCat() {
    this.ctx.votesStore.setState((prev) => ({
      ...prev,
      cats: prev.cats + 1,
    }))
  }

  addDog() {
    this.ctx.votesStore.setState((prev) => ({
      ...prev,
      dogs: prev.dogs + 1,
    }))
  }
}

Vue Example: Store Context

<script setup lang="ts">
import { defineComponent, h, inject, provide } from 'vue'
import {
  createAtom,
  createStore,
  useAtom,
  useSelector,
} from '@tanstack/vue-store'
import type { Atom, Store } from '@tanstack/vue-store'
import type { InjectionKey } from 'vue'

// one drawback of storing stores and atoms in context is you have to define types for the context manually, instead of everything being inferred.

type CounterStore = {
  cats: number
  dogs: number
}

type StoreContextValue = {
  votesStore: Store<CounterStore>
  countAtom: Atom<number>
}

const StoreContextKey = Symbol(
  'StoreContext',
) as InjectionKey<StoreContextValue>

function useStoreContext() {
  const value = inject(StoreContextKey)

  if (!value) {
    throw new Error('Missing StoreProvider for StoreContext')
  }

  return value
}

// Vue setup runs once per component instance, so stores and atoms created here stay stable for this provider instance.
const votesStore = createStore<CounterStore>({
  cats: 0,
  dogs: 0,
})
const countAtom = createAtom(0)

provide(StoreContextKey, { votesStore, countAtom })

const CatCard = defineComponent(() => {
  const { votesStore } = useStoreContext()
  // select a value from the store with useSelector
  const value = useSelector(votesStore, (state) => state.cats)

  return () => h('p', `Cats: ${value.value}`)
})

const DogCard = defineComponent(() => {
  const { votesStore } = useStoreContext()
  // select a value from the store with useSelector
  const value = useSelector(votesStore, (state) => state.dogs)

  return () => h('p', `Dogs: ${value.value}`)
})

const TotalCard = defineComponent(() => {
  const { votesStore } = useStoreContext()
  // custom selector to calculate total votes from the store state
  const total = useSelector(votesStore, (state) => state.cats + state.dogs)

  return () => h('p', `Total votes: ${total.value}`)
})

const AtomSummary = defineComponent(() => {
  const { countAtom } = useStoreContext()
  const count = useSelector(countAtom)

  return () => h('p', `Atom count: ${count.value}`)
})

const NestedAtomControls = defineComponent(() => {
  const { countAtom } = useStoreContext()

  return () =>
    h('div', [
      h(
        'button',
        {
          type: 'button',
          onClick: () => countAtom.set((prev: number) => prev + 1),
        },
        'Increment atom',
      ),
      h(
        'button',
        { type: 'button', onClick: () => countAtom.set(0) },
        'Reset atom',
      ),
    ])
})

const DeepAtomEditor = defineComponent(() => {
  const { countAtom } = useStoreContext()
  const [count, setCount] = useAtom(countAtom)

  return () =>
    h('div', [
      h('p', `Editable atom count: ${count.value}`),
      h(
        'button',
        { type: 'button', onClick: () => setCount((prev: number) => prev + 5) },
        'Add 5 to atom',
      ),
    ])
})

const StoreButtons = defineComponent(() => {
  const { votesStore } = useStoreContext()

  return () =>
    h('div', [
      h(
        'button',
        {
          type: 'button',
          onClick: () =>
            votesStore.setState((prev: CounterStore) => ({
              ...prev,
              cats: prev.cats + 1,
            })),
        },
        'Add cat',
      ),
      h(
        'button',
        {
          type: 'button',
          onClick: () =>
            votesStore.setState((prev: CounterStore) => ({
              ...prev,
              dogs: prev.dogs + 1,
            })),
        },
        'Add dog',
      ),
    ])
})
</script>

<template>
  <main>
    <h1>Vue Store Context</h1>
    <p>
      This example provides both atoms and stores through a single typed context
      object, then consumes them from nested components.
    </p>
    <CatCard />
    <DogCard />
    <TotalCard />
    <StoreButtons />
    <section>
      <h2>Nested Atom Components</h2>
      <AtomSummary />
      <NestedAtomControls />
      <DeepAtomEditor />
    </section>
  </main>
</template>
<script setup lang="ts">
import { defineComponent, h, inject, provide } from 'vue'
import {
  createAtom,
  createStore,
  useAtom,
  useSelector,
} from '@tanstack/vue-store'
import type { Atom, Store } from '@tanstack/vue-store'
import type { InjectionKey } from 'vue'

// one drawback of storing stores and atoms in context is you have to define types for the context manually, instead of everything being inferred.

type CounterStore = {
  cats: number
  dogs: number
}

type StoreContextValue = {
  votesStore: Store<CounterStore>
  countAtom: Atom<number>
}

const StoreContextKey = Symbol(
  'StoreContext',
) as InjectionKey<StoreContextValue>

function useStoreContext() {
  const value = inject(StoreContextKey)

  if (!value) {
    throw new Error('Missing StoreProvider for StoreContext')
  }

  return value
}

// Vue setup runs once per component instance, so stores and atoms created here stay stable for this provider instance.
const votesStore = createStore<CounterStore>({
  cats: 0,
  dogs: 0,
})
const countAtom = createAtom(0)

provide(StoreContextKey, { votesStore, countAtom })

const CatCard = defineComponent(() => {
  const { votesStore } = useStoreContext()
  // select a value from the store with useSelector
  const value = useSelector(votesStore, (state) => state.cats)

  return () => h('p', `Cats: ${value.value}`)
})

const DogCard = defineComponent(() => {
  const { votesStore } = useStoreContext()
  // select a value from the store with useSelector
  const value = useSelector(votesStore, (state) => state.dogs)

  return () => h('p', `Dogs: ${value.value}`)
})

const TotalCard = defineComponent(() => {
  const { votesStore } = useStoreContext()
  // custom selector to calculate total votes from the store state
  const total = useSelector(votesStore, (state) => state.cats + state.dogs)

  return () => h('p', `Total votes: ${total.value}`)
})

const AtomSummary = defineComponent(() => {
  const { countAtom } = useStoreContext()
  const count = useSelector(countAtom)

  return () => h('p', `Atom count: ${count.value}`)
})

const NestedAtomControls = defineComponent(() => {
  const { countAtom } = useStoreContext()

  return () =>
    h('div', [
      h(
        'button',
        {
          type: 'button',
          onClick: () => countAtom.set((prev: number) => prev + 1),
        },
        'Increment atom',
      ),
      h(
        'button',
        { type: 'button', onClick: () => countAtom.set(0) },
        'Reset atom',
      ),
    ])
})

const DeepAtomEditor = defineComponent(() => {
  const { countAtom } = useStoreContext()
  const [count, setCount] = useAtom(countAtom)

  return () =>
    h('div', [
      h('p', `Editable atom count: ${count.value}`),
      h(
        'button',
        { type: 'button', onClick: () => setCount((prev: number) => prev + 5) },
        'Add 5 to atom',
      ),
    ])
})

const StoreButtons = defineComponent(() => {
  const { votesStore } = useStoreContext()

  return () =>
    h('div', [
      h(
        'button',
        {
          type: 'button',
          onClick: () =>
            votesStore.setState((prev: CounterStore) => ({
              ...prev,
              cats: prev.cats + 1,
            })),
        },
        'Add cat',
      ),
      h(
        'button',
        {
          type: 'button',
          onClick: () =>
            votesStore.setState((prev: CounterStore) => ({
              ...prev,
              dogs: prev.dogs + 1,
            })),
        },
        'Add dog',
      ),
    ])
})
</script>

<template>
  <main>
    <h1>Vue Store Context</h1>
    <p>
      This example provides both atoms and stores through a single typed context
      object, then consumes them from nested components.
    </p>
    <CatCard />
    <DogCard />
    <TotalCard />
    <StoreButtons />
    <section>
      <h2>Nested Atom Components</h2>
      <AtomSummary />
      <NestedAtomControls />
      <DeepAtomEditor />
    </section>
  </main>
</template>

Svelte Example: Store Context

<script lang="ts">
  import { setContext } from 'svelte'
  import { createAtom, createStore } from '@tanstack/svelte-store'
  import AtomSection from './AtomSection.svelte'
  import StoreSection from './StoreSection.svelte'
  import { STORE_CONTEXT } from './context'
  import type { CounterStore } from './context'

  // one drawback of storing stores and atoms in context is you have to define types for the context manually, instead of everything being inferred.

  // Svelte components initialize once per mount, so stores and atoms created here stay stable for this provider instance.
  const votesStore = createStore<CounterStore>({
    cats: 0,
    dogs: 0,
  })
  const countAtom = createAtom(0)

  setContext(STORE_CONTEXT, { votesStore, countAtom })
</script>

<main>
  <h1>Svelte Store Context</h1>
  <p>
    This example provides both atoms and stores through a single typed context
    object, then consumes them from nested components.
  </p>
  <StoreSection />
  <AtomSection />
</main>
<script lang="ts">
  import { setContext } from 'svelte'
  import { createAtom, createStore } from '@tanstack/svelte-store'
  import AtomSection from './AtomSection.svelte'
  import StoreSection from './StoreSection.svelte'
  import { STORE_CONTEXT } from './context'
  import type { CounterStore } from './context'

  // one drawback of storing stores and atoms in context is you have to define types for the context manually, instead of everything being inferred.

  // Svelte components initialize once per mount, so stores and atoms created here stay stable for this provider instance.
  const votesStore = createStore<CounterStore>({
    cats: 0,
    dogs: 0,
  })
  const countAtom = createAtom(0)

  setContext(STORE_CONTEXT, { votesStore, countAtom })
</script>

<main>
  <h1>Svelte Store Context</h1>
  <p>
    This example provides both atoms and stores through a single typed context
    object, then consumes them from nested components.
  </p>
  <StoreSection />
  <AtomSection />
</main>